unit graphobj;

interface
 Type TGraphObj=object
  x,y,size:integer;
  color:word;
  Constructor Init(ix,iy,isize:integer;icolor:word);
  Procedure Draw(acolor:word); virtual;
  Procedure Show;
  Procedure Hide;
 end;

 TCircle=object(TGraphObj)
  Procedure draw(acolor:word); virtual;
 end;

 THand=object(TGraphObj)
  dx,dy:integer;
  Constructor Init(ix,iy,isize:integer;icolor:word);
  Procedure Rotate(angle:integer);
  Procedure draw(acolor:word);virtual;
 end;

 TDial=object(TCircle)
  Procedure draw(acolor:word);virtual;
 end;

implementation
 uses graph;

 constructor TGraphObj.init;
 begin
  x:=ix;
  y:=iy;
  size:=isize;
  color:=icolor;
 end;

 procedure TGraphObj.draw;
 begin
 end;

 procedure TGraphObj.Show;
 begin
  draw(color);
 end;

 procedure TGraphObj.Hide;
 begin
  draw(GetBkColor);
 end;

 procedure TCircle.draw;
 begin
  SetColor(acolor);
  circle(x,y,size);
 end;

 Constructor THand.Init;
 begin
  inherited init(ix,iy,isize,icolor);
  dx:=0;dy:=size;
 end;

 procedure THand.draw;
 begin
  SetColor(acolor);
  line(x,y,x+dx,y+dy);
 end;

 procedure THand.Rotate;
 begin
  Hide;
  dx:=Round(size*cos(angle*pi/180));
  dy:=Round(size*sin(angle*pi/180));
  Show;
 end;

 procedure TDial.Draw;
 var
  i :integer;
 begin
  inherited draw(color);
  OutTextXY(x-50,y-50,'Muraveva Vera');
  OutTextXY(x-40,y+20,'MGAPI 2004');
  for i:=0 to 60 do
   if i mod 5 = 0 then
    Circle(Round(x+(size-20)*cos(i*pi/30)),
            Round(y+(size-20)*sin(i*pi/30)),10)
   else
    PutPixel(Round(x+(size-20)*cos(i*pi/30)),
            Round(y+(size-20)*sin(i*pi/30)),color);
 end;

end.